<?php
error_reporting(E_ALL);
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version 1.1.3
 * ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an  "AS IS"  basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 * 
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the "Powered by SugarCRM" logo and 
 * (ii) the SugarCRM copyright notice 
 * in the same form as they appear in the distribution.  See full license for requirements.
 * 
 * The Original Code is:  SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/
/*********************************************************************************
 * $Header: /home/httpd/vhosts/sugarcrm.com/master/sugarcrm/index.php,v 1.104 2004/10/25 03:29:15 clint Exp $
 * Description: Main file and starting point for the application.  Calls the
 * theme header and footer files defined for the user as well as the module as
 * defined by the input parameters.
 ********************************************************************************/
ob_start();
if (substr(phpversion(), 0, 1) == "5") {
	ini_set("zend.ze1_compatibility_mode", "1");
}
$xss_cleanup=  array('"' =>'&quot;', "'" =>  '&#039;' , '<' =>'&lt;' , '>'=>'&gt;');
function securexss($value){
	global $xss_cleanup;
		$value = preg_replace('/javascript:/i', 'java script:', $value);
		return str_replace(array_keys($xss_cleanup), array_values($xss_cleanup), $value);
}


 function preprocess_param($value){
 	if(is_string($value)){
	 	if(get_magic_quotes_gpc() == 1){
	 		$value = stripslashes($value);
	 	}
	 	$value = securexss($value);
 	}
 	return $value;


 }


 if(get_magic_quotes_gpc() == 1){
 	$_REQUEST = array_map("preprocess_param", $_REQUEST);
	$_POST = array_map("preprocess_param", $_POST);
	$_GET = array_map("preprocess_param", $_GET);

}
// Allow for the session information to be passed via the URL for printing.
if(isset($_REQUEST['PHPSESSID']))
{
	session_id($_REQUEST['PHPSESSID']);
}

function insert_charset_header()
{
global $app_strings, $default_charset;
$charset = $default_charset;

if(isset($app_strings['LBL_CHARSET']))
{
	$charset = $app_strings['LBL_CHARSET'];
}
header('Content-Type: text/html; charset='.$charset);
}

insert_charset_header();
// Create or reestablish the current session
session_start();



if (!is_file('config.php')) {
    header("Location: install.php");
    exit();
}
require_once('config.php');

require_once('include/modules.php');

if (!isset($dbconfig['db_host_name'])) {
    header("Location: install.php");
    exit();
}

// load up the config_override.php file.  This is used to provide default user settings
if (is_file('config_override.php'))
{
	require_once('config_override.php');
}

require_once('include/logging.php');

require_once('modules/Users/User.php');
global $currentModule, $moduleList;

if($calculate_response_time) $startTime = microtime();

if (isset($simple_log))
{
	$log = new SimpleLog();
}
else
{
	$log =& LoggerManager::getLogger('index');
}
if (isset($_REQUEST['PHPSESSID'])) $log->debug("****Starting for session ".$_REQUEST['PHPSESSID']);
else $log->debug("****Starting for new session");

// We use the REQUEST_URI later to construct dynamic URLs.  IIS does not pass this field
// to prevent an error, if it is not set, we will assign it to ''
if(!isset($_SERVER['REQUEST_URI']))
{
	$_SERVER['REQUEST_URI'] = '';
}

if(isset($_REQUEST['action']))
{
	$action = $_REQUEST['action'];
}

if(isset($_REQUEST['module']))
{
	$module = $_REQUEST['module'];
}

// Check to see if there is an authenticated user in the session.
if(isset($_SESSION["authenticated_user_id"]))
{
	$log->debug("We have an authenticated user id: ".$_SESSION["authenticated_user_id"]);
}
else if(isset($action) && isset($module) && $action=="Authenticate" && $module=="Users")
{
	$log->debug("We are authenticating user now");
}
else
{
	$log->debug("The current user does not have a session.  Going to the login page");
	$action = "Login";
	$module = "Users";
	$_REQUEST['action'] = $action;
	$_REQUEST['module'] = $module;
}


//test code.....should not ship
//test code.....should not ship
//test code.....should not ship
//test code.....should not ship

//test code.....should not ship
//test code.....should not ship
//test code.....should not ship
//test code.....should not ship
//test code.....should not ship


$log->debug($_REQUEST);

$skipHeaders=false;
$skipFooters=false;

if(isset($action) && isset($module))
{
	$log->info("About to take action ".$action);
	$log->debug("in $action");
	if(ereg("^Save", $action) || ereg("^Delete", $action) || ereg("^Popup", $action) || ereg("^ChangePassword", $action) || ereg("^Authenticate", $action) || ereg("^Logout", $action) || ereg("^Export",$action))
	{
		$skipHeaders=true;
		if(ereg("^Popup", $action) || ereg("^ChangePassword", $action) || ereg("^Export", $action))
			$skipFooters=true;
	}
	if(isset($_REQUEST['from']) && $_REQUEST['from']=='ImportVCard'){
		$skipHeaders=true;
		$skipFooters=true;
	}
	if($action == 'BusinessCard' || $action == 'ConvertLead'|| $action == 'Save'){
		header( "Expires: Mon, 20 Dec 1998 01:00:00 GMT" );
   		header( "Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT" );
    	header( "Cache-Control: no-cache, must-revalidate" );
    	header( "Pragma: no-cache" );
	}

	if ( $action == "Import" &&
		isset($_REQUEST['step']) &&
		$_REQUEST['step'] == '4'  )
	{
		$skipHeaders=true;
		$skipFooters=true;
	}


	$currentModuleFile = 'modules/'.$module.'/'.$action.'.php';
	$currentModule = $module;
}
elseif(isset($module))
{
	$currentModule = $module;
	$currentModuleFile = $moduleDefaultFile[$currentModule];
}
else {
    // use $default_module and $default_action as set in config.php
    // Redirect to the correct module with the correct action.  We need the URI to include these fields.
    header("Location: index.php?action=$default_action&module=$default_module");
    exit();
}

$log->info("current page is $currentModuleFile");
$log->info("current module is $currentModule ");
//define default home pages for each module
foreach ($moduleList as $mod) {
	$moduleDefaultFile[$mod] = "modules/".$currentModule."/index.php";
}

// for printing
$GLOBALS['request_string'] = "";

$append_amp = FALSE;
foreach ($_GET as $key => $val) {
	if ($append_amp) {
		$GLOBALS['request_string'] .= "&";
	}
	else {
		$append_amp = TRUE;
	}
	$GLOBALS['request_string'] .= "{$key}={$val}";
}

$GLOBALS['request_string'] .= ($append_amp) ? "&print=true" : "print=true";
// end printing

$current_user = new User();

if(isset($_SESSION['authenticated_user_id']))
{
	$result = $current_user->retrieve($_SESSION['authenticated_user_id']);
	if($result == null)
	{
		session_destroy();
	    header("Location: index.php?action=Login&module=Users");
	}

	$log->debug('Current user is: '.$current_user->user_name);
}

if(isset($_SESSION['authenticated_user_theme']) && $_SESSION['authenticated_user_theme'] != '')
{
	$theme = $_SESSION['authenticated_user_theme'];
}
else
{
	$theme = $default_theme;
}
$log->debug('Current theme is: '.$theme);

//Used for current record focus
$focus = "";

// if the language is not set yet, then set it to the default language.
if(isset($_SESSION['authenticated_user_language']) && $_SESSION['authenticated_user_language'] != '')
{
	$current_language = $_SESSION['authenticated_user_language'];
}
else
{
	$current_language = $default_language;
}
$log->debug('current_language is: '.$current_language);

//set module and application string arrays based upon selected language
$app_strings = return_application_language($current_language);
$app_list_strings = return_app_list_strings_language($current_language);
$mod_strings = return_module_language($current_language, $currentModule);

//TODO: Clint - this key map needs to be moved out of $app_list_strings since it never gets translated.
//              best to just have an upgrade script that changes the parent_type column from Account to Accounts, etc.
$app_list_strings['record_type_module'] = array('Contact'=>'Contacts', 'Account'=>'Accounts', 'Opportunity'=>'Opportunities', 'Case'=>'Cases', 'Note'=>'Notes', 'Call'=>'Calls', 'Email'=>'Emails', 'Meeting'=>'Meetings', 'Task'=>'Tasks', 'Lead'=>'Leads', 



);

//If DetailView, set focus to record passed in
if($action == "DetailView")
{
	if(!isset($_REQUEST['record']))
		die("A record number must be specified to view details.");

	// If we are going to a detail form, load up the record now.
	// Use the record to track the viewing.
	// todo - Have a record of modules and thier primary object names.
	$entity = $beanList[$currentModule];
	require_once($beanFiles[$entity]);
	$focus = new $entity();

	$result = $focus->retrieve($_REQUEST['record']);

	if($result)
	{
		// Only track a viewing if the record was retrieved.
		$focus->track_view($current_user->id, $currentModule);
	}
}

// set user, theme and language cookies so that login screen defaults to last values
if (isset($_SESSION['authenticated_user_id'])) {
	$log->debug("setting cookie ck_login_id_20 to ".$_SESSION['authenticated_user_id']);
	setcookie('ck_login_id_20', $_SESSION['authenticated_user_id']);
}
if (isset($_SESSION['authenticated_user_theme'])) {
	$log->debug("setting cookie ck_login_theme_20 to ".$_SESSION['authenticated_user_theme']);
	setcookie('ck_login_theme_20', $_SESSION['authenticated_user_theme']);
}
if (isset($_SESSION['authenticated_user_language'])) {
	$log->debug("setting cookie ck_login_language_20 to ".$_SESSION['authenticated_user_language']);
	setcookie('ck_login_language_20', $_SESSION['authenticated_user_language']);
}
	echo '<script  src="include/javascript/sugar.js"></script>';
	echo '<link rel="stylesheet" type="text/css" media="all" href="jscalendar/calendar-win2k-cold-1.css">';
	echo '<script type="text/javascript" src="jscalendar/calendar.js"></script>';
	echo '<script type="text/javascript" src="jscalendar/lang/calendar-en.js"></script>';
	echo '<script type="text/javascript" src="jscalendar/calendar-setup.js"></script>';
//skip headers for popups, deleting, saving, importing and other actions
if(!$skipHeaders) {

	$log->debug("including headers");

	if (!is_file('themes/'.$theme.'/header.php')) {
		$theme = $default_theme;
	}
	if (!is_file('themes/'.$theme.'/header.php')) {
		sugar_die("Invalid theme specificed");
	}

	include('themes/'.$theme.'/header.php');

	if(isset($_SESSION['administrator_error']))
	{
		// only print DB errors once otherwise they will still look broken after they are fixed.
		// Only print the errors for admin users.
		if(is_admin($current_user))
			echo $_SESSION['administrator_error'];
		unset($_SESSION['administrator_error']);
	}

	echo "<!-- crmprint -->";
}
else {
		$log->debug("skipping headers");
}

include($currentModuleFile);

echo "<!-- crmprint -->";

if(!$skipFooters) {
	include('themes/'.$theme.'/footer.php');


echo "<table cellpadding='0' cellspacing='0' width='100%'><tr><td align='center' class='copyRight'>";
// Under the Sugar Public License referenced above, you are required to leave in all copyright statements in both
// the code and end-user application.
echo("<p>&copy; 2004 <a href='http://www.sugarcrm.com' target='_blank'  class='copyRightLink'>SugarCRM Inc.</a> All Rights Reserved.<br>");

if($calculate_response_time)
{
    $endTime = microtime();

    $deltaTime = microtime_diff($startTime, $endTime);
    echo('Server response time: '.$deltaTime.' seconds.</p>');
}
// You are encouraged, but not required, to leave the Powered by SugarCRM logo in the end-user application.
echo "<p><A href='http://www.sugarcrm.com' target='_blank'><img border='0' src='include/images/powered_by_sugarcrm.gif' alt='Powered By SugarCRM'></a></p>\n";
echo "</td></tr></table>\n";
echo "</body></html>";
}
include_once 'include/replacePngTags.php';

if (isset($_GET['print'])) {
	$page_str = ob_get_clean();
	$page_arr = explode("<!-- crmprint -->", $page_str);
	include("phprint.php");
}
else {
	echo replacePngTags(ob_get_clean());
}

?>
