<?php
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version 1.1.3
 * ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an  "AS IS"  basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 * 
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the "Powered by SugarCRM" logo and 
 * (ii) the SugarCRM copyright notice 
 * in the same form as they appear in the distribution.  See full license for requirements.
 * 
 * The Original Code is:  SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/
/*********************************************************************************
 * $Header: /home/httpd/vhosts/sugarcrm.com/master/sugarcrm/install/1checkSystem.php,v 1.27 2004/10/24 20:06:42 clint Exp $
 * Description:  Executes a step in the installation process.
 ********************************************************************************/

//get php configuration settings.  requires elaborate parsing of phpinfo() output
ob_start();
phpinfo(INFO_GENERAL);
$string = ob_get_contents();
ob_end_clean();

$pieces = explode("<h2", $string);
$settings = array();
foreach($pieces as $val)
{
   preg_match("/<a name=\"module_([^<>]*)\">/", $val, $sub_key);
   preg_match_all("/<tr[^>]*>
									   <td[^>]*>(.*)<\/td>
									   <td[^>]*>(.*)<\/td>/Ux", $val, $sub);
   preg_match_all("/<tr[^>]*>
									   <td[^>]*>(.*)<\/td>
									   <td[^>]*>(.*)<\/td>
									   <td[^>]*>(.*)<\/td>/Ux", $val, $sub_ext);
   foreach($sub[0] as $key => $val) {
		if (preg_match("/Configuration File \(php.ini\) Path /", $val)) {
	   		$val = preg_replace("/Configuration File \(php.ini\) Path /", '', $val);
			$phpini = strip_tags($val);
	   	}
   }

}

$gd_info_alternate = 'function gd_info() {
$array = Array(
"GD Version" => "",
"FreeType Support" => 0,
"FreeType Support" => 0,
"FreeType Linkage" => "",
"T1Lib Support" => 0,
"GIF Read Support" => 0,
"GIF Create Support" => 0,
"JPG Support" => 0,
"PNG Support" => 0,
"WBMP Support" => 0,
"XBM Support" => 0
);
$gif_support = 0;

ob_start();
eval("phpinfo();");
$info = ob_get_contents();
ob_end_clean();

foreach(explode("\n", $info) as $line) {
if(strpos($line, "GD Version")!==false)
$array["GD Version"] = trim(str_replace("GD
Version", "", strip_tags($line)));
if(strpos($line, "FreeType Support")!==false)
$array["FreeType Support"] = trim(str_replace
("FreeType Support", "", strip_tags($line)));
if(strpos($line, "FreeType Linkage")!==false)
$array["FreeType Linkage"] = trim(str_replace
("FreeType Linkage", "", strip_tags($line)));
if(strpos($line, "T1Lib Support")!==false)
$array["T1Lib Support"] = trim(str_replace
("T1Lib Support", "", strip_tags($line)));
if(strpos($line, "GIF Read Support")!==false)
$array["GIF Read Support"] = trim(str_replace
("GIF Read Support", "", strip_tags($line)));
if(strpos($line, "GIF Create Support")!==false)
$array["GIF Create Support"] = trim
(str_replace("GIF Create Support", "", strip_tags($line)));
if(strpos($line, "GIF Support")!==false)
$gif_support = trim(str_replace("GIF
Support", "", strip_tags($line)));
if(strpos($line, "JPG Support")!==false)
$array["JPG Support"] = trim(str_replace("JPG
Support", "", strip_tags($line)));
if(strpos($line, "PNG Support")!==false)
$array["PNG Support"] = trim(str_replace
("PNG Support", "", strip_tags($line)));
if(strpos($line, "WBMP Support")!==false)
$array["WBMP Support"] = trim(str_replace
("WBMP Support", "", strip_tags($line)));
if(strpos($line, "XBM Support")!==false)
$array["XBM Support"] = trim(str_replace
("XBM Support", "", strip_tags($line)));
}

if($gif_support==="enabled") {
$array["GIF Read Support"] = 1;
$array["GIF Create Support"] = 1;
}

if($array["FreeType Support"]==="enabled"){
$array["FreeType Support"] = 1; }

if($array["T1Lib Support"]==="enabled")
$array["T1Lib Support"] = 1;

if($array["GIF Read Support"]==="enabled"){
$array["GIF Read Support"] = 1; }

if($array["GIF Create Support"]==="enabled")
$array["GIF Create Support"] = 1;

if($array["JPG Support"]==="enabled")
$array["JPG Support"] = 1;

if($array["PNG Support"]==="enabled")
$array["PNG Support"] = 1;

if($array["WBMP Support"]==="enabled")
$array["WBMP Support"] = 1;

if($array["XBM Support"]==="enabled")
$array["XBM Support"] = 1;

return $array;
}';

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<HTML>
<HEAD>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<title>Sugar Sales Setup Wizard: Step 1</title>
<link rel="stylesheet" href="install/install.css" type="text/css" />
</head>
<body>
<table cellspacing="0" cellpadding="0" border="0" align="center" class="shell">
<tr>
    <th width="400">Step 1: System Check</th>
	<th width="200"><a href="http://www.sugarcrm.com" target="_blank"><img src="include/images/sugarcrm_logo.gif" alt="" width="150" height="29" border="0" align="right"></a></th>
</tr>
<tr>
    <td colspan="2" width="600">
	<p>In order for your Sugar Sales installation to function properly, please ensure all of the
	system check items listed below are green.  If any are red, please take the necessary steps
	to fix them.</p> 

	
	<table cellpadding="0" cellspacing="0" border="0" width="100%" class="StyleDottedHr">
		<tr>
			<th align="left">Component</th>			
			<th style="text-align: right;">Status</th>
    	</tr>
		<tr>
			<td><b>PHP version 4.2.x or 4.3.x.</b><BR><i>
			<span class="small">-NOTE: Charts are not supported in PHP5</span></i></td>
			<td align="right" valign="top"><?php $php_version = phpversion(); echo (str_replace(".", "", $php_version) < "420") ? "<b><span class=stop>Invalid version ($php_version) Installed</span></b>" : "<b><span class=go>Version $php_version Installed</span></b>"; ?></td>
    	</tr>
		<tr>
			<td><strong>MySQL database</strong></td>
        	<td align="right"><?php echo function_exists('mysql_connect')?"<b><span class=go>Available</font></b>":"<b><span class=stop>Not Available</font></b>";?></td>
	    </tr>
		<tr>
			<td><b>config.php</b></td>
			<td align="right"><?php echo (is_writable('./config.php') || is_writable('.'))?"<b><span class=go>Writeable</font></b>":"<b><span class=stop>Not Writeable</font></b>"; ?></td>
		</tr>
		<tr>
			<td><b>Cache Directory (cache/)</b></td>
			<td align="right"><?php echo (is_writable('./cache/'))?"<b><span class=go>Writeable</font></b>":"<b><span class=stop>Not Writeable</font></b>"; ?></td>
		</tr>
		<tr>
			<td><b>GD graphics library version 2.0 or later</b></td>
			<td align="right"><?php
								if (!extension_loaded('gd')) {
									echo "<b><span class=stop><span class=small>GD Library not configured in your PHP installation.<br>Check out our <a href='http://sourceforge.net/docman/?group_id=107819'>online documentation</a> for tips on enabling this library. You can ignore this error and continue your SugarCRM installation, however the chart images simply won't work.</span></span></b>";
								}
								else {
									if (function_exists('gd_info'))
										$gd_info = gd_info();
									else
										eval($gd_info_alternate);

									if (isset($gd_info['GD Version'])) {
										$gd_version = $gd_info['GD Version'];
										$gd_version=preg_replace('%[^0-9.]%', '', $gd_version);
										if ($gd_version > "2.0") {
											echo "<b><span class=go>Version $gd_version Installed</span></b>";
										}
										else {
											echo "<b><span class=stop>Version $gd_version Installed.<br>Go to <a href='http://www.boutell.com/gd/'>http://www.boutell.com/gd/</a>, download the latest version, and configure php.ini to reference it.</span></b>";
										}
									}
									else {
										echo "<b><span class=stop><span class=small>GD Library available, but not properly configured in your PHP installation.<br>Check out our <a href='http://sourceforge.net/docman/?group_id=107819'>online documentation</a> for tips on enabling this library. You can ignore this error and continue your SugarCRM installation, however the chart images simply won't work.</span></span></b>";
									}
								}
								?>
			</td>
		</tr>
	</table>
	<div align="center" style="margin: 5px;"><i><b>Note:</b> Your php configuration file (php.ini)
			is located at: <br><?php echo $phpini;?></b></i></div>
	</td>
</tr>
<tr>
	<td align="right" colspan="2">
	<hr>
	
		<table cellspacing="0" cellpadding="0" border="0" class="stdTable">
			<tr>
			    <td><input class="button" type="button" name="cancel" value="Cancel"  onclick="window.close();"/>&nbsp;&nbsp;&nbsp;&nbsp;<input class="button" type="button" name="back" value="Back"  onclick="history.back()"/></td>
			    <form action="install.php" method="post" name="form" id="form"><td>
			<input type="hidden" name="file" value="2setConfig.php" />
			<input class="button" type="submit" name="next" value="Next" />
					</form></td>
			</tr>
		</table>

		
	</td>
</tr>
</table>
<br>

</body>
</html>

