<?php
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version 1.1.3
 * ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an  "AS IS"  basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 * 
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the "Powered by SugarCRM" logo and 
 * (ii) the SugarCRM copyright notice 
 * in the same form as they appear in the distribution.  See full license for requirements.
 * 
 * The Original Code is:  SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/
/*********************************************************************************
 * $Header: /home/httpd/vhosts/sugarcrm.com/master/sugarcrm/install/2setConfig.php,v 1.28 2004/10/24 20:06:42 clint Exp $
 * Description:  Executes a step in the installation process.
 ********************************************************************************/

$web_root = $_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF'];
$web_root = str_replace("/install.php", "", $web_root);
$web_root = "http://$web_root";
$current_dir = str_replace('\install',"", dirname(__FILE__));
$current_dir = str_replace('/install',"", $current_dir);
$current_dir = trim($current_dir);
$cache_dir = "cache/";

if (is_file("config.php")) {
	require_once("config.php");

	session_start();
	if(isset($disable_persistent_connections))
		$_SESSION['disable_persistent_connections'] = $disable_persistent_connections;
	if(isset($default_language))
		$_SESSION['default_language'] = $default_language;
	if(isset($translation_string_prefix))
		$_SESSION['translation_string_prefix'] = $translation_string_prefix;
	if(isset($default_charset))
		$_SESSION['default_charset'] = $default_charset;
	if(isset($languages))
	{
		// We need to encode the languages in a way that can be retrieved later.
		$language_keys = Array();
		$language_values = Array();

		foreach($languages as $key=>$value)
		{
			$language_keys[] = $key;
			$language_values[] = $value;
		}

		$_SESSION['language_keys'] = urlencode(implode(",",$language_keys));
		$_SESSION['language_values'] = urlencode(implode(",",$language_values));
	}

	global $dbconfig;
	if (isset($_REQUEST['db_host_name'])) {
		$db_host_name = $_REQUEST['db_host_name'];
	}
	elseif (isset($dbconfig['db_host_name'])) {
		$db_host_name = $dbconfig['db_host_name'];
	}
	else {
		$db_host_name = 'localhost';
	}

	if (isset($_REQUEST['db_user_name'])) {
		$db_user_name = $_REQUEST['db_user_name'];
	}
	elseif (isset($dbconfig['db_user_name'])) {
		$db_user_name = $dbconfig['db_user_name'];
	}
	else {
		$db_user_name = 'sugarcrm';
	}

	if (isset($_REQUEST['db_password'])) {
		$db_password = $_REQUEST['db_password'];
	}
	elseif (isset($dbconfig['db_password'])) {
		$db_password = $dbconfig['db_password'];
	}
	else {
		$db_password = '';
	}

	if (isset($_REQUEST['db_name'])){
		$db_name = $_REQUEST['db_name'];
	}
	elseif (isset($dbconfig['db_name'])) {
		$db_name = $dbconfig['db_name'];
	}
	else {
		$db_name = 'sugarcrm';
	}
	!isset($_REQUEST['db_drop_tables']) ? $db_drop_tables = "0" : $db_drop_tables = $_REQUEST['db_drop_tables'];

	if (isset($_REQUEST['host_name'])) $host_name = $_REQUEST['host_name'];
	else $host_name = $_SERVER['SERVER_NAME'];
	if (isset($_REQUEST['site_URL'])) $site_URL = $_REQUEST['site_URL'];
	else $site_URL = $web_root;
	if (isset($_REQUEST['root_directory'])) $root_directory = stripslashes($_REQUEST['root_directory']);
	else $root_directory = $current_dir;
	if (isset($_REQUEST['cache_dir'])) $cache_dir= $_REQUEST['cache_dir'];
	if (isset($_REQUEST['admin_email'])) $admin_email = $_REQUEST['admin_email'];
	if (isset($_REQUEST['admin_password'])) $admin_password = $_REQUEST['admin_password'];
}
else {
	!isset($_REQUEST['db_host_name']) ? $db_host_name = "localhost" : $db_host_name = $_REQUEST['db_host_name'];
	!isset($_REQUEST['db_user_name']) ? $db_user_name = "sugarcrm" : $db_user_name = $_REQUEST['db_user_name'];
	!isset($_REQUEST['db_password']) ? $db_password= "" : $db_password = $_REQUEST['db_password'];
	!isset($_REQUEST['db_name']) ? $db_name = "sugarcrm" : $db_name = $_REQUEST['db_name'];
	!isset($_REQUEST['db_drop_tables']) ? $db_drop_tables = "0" : $db_drop_tables = $_REQUEST['db_drop_tables'];
	!isset($_REQUEST['host_name']) ? $host_name= $_SERVER['SERVER_NAME'] : $host_name= $_REQUEST['host_name'];
	!isset($_REQUEST['site_URL']) ? $site_URL = $web_root : $site_URL = $_REQUEST['site_URL'];
	!isset($_REQUEST['root_directory']) ? $root_directory = $current_dir : $root_directory = stripslashes($_REQUEST['root_directory']);
	!isset($_REQUEST['cache_dir']) ? $cache_dir = $cache_dir : $cache_dir = stripslashes($_REQUEST['cache_dir']);
	!isset($_REQUEST['admin_email']) ? $admin_email = "" : $admin_email = $_REQUEST['admin_email'];
}

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<HTML>
<HEAD>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<title>Sugar Sales Setup Wizard: Step 2 </title>
<link rel="stylesheet" href="install/install.css" type="text/css" />

<script type="text/javascript" language="Javascript">
<!--  to hide script contents from old browsers

function trim(s) {
	while (s.substring(0,1) == " ") {
		s = s.substring(1, s.length);
	}
	while (s.substring(s.length-1, s.length) == ' ') {
		s = s.substring(0,s.length-1);
	}

	return s;
}

function verify_data(form) {
	var isError = false;
	var errorMessage = "";
	// Here we decide whether to submit the form.
	if (trim(form.db_host_name.value) =='') {
		isError = true;
		errorMessage += "\n database host name";
		form.db_host_name.focus();
	}
	if (trim(form.db_user_name.value) =='') {
		isError = true;
		errorMessage += "\n database user name";
		form.db_user_name.focus();
	}
	if (trim(form.db_name.value) =='') {
		isError = true;
		errorMessage += "\n database name";
		form.db_name.focus();
	}
	if (trim(form.site_URL.value) =='') {
		isError = true;
		errorMessage += "\n site url";
		form.site_URL.focus();
	}
	if (trim(form.root_directory.value) =='') {
		isError = true;
		errorMessage += "\n path";
		form.root_directory.focus();
	}
	if (trim(form.admin_password.value) =='') {
		isError = true;
		errorMessage += "\n admin password";
		form.admin_password.focus();
	}
	if (trim(form.cache_dir.value) =='') {
		isError = true;
		errorMessage += "\n temp directory path";
		form.root_directory.focus();
	}

	// Here we decide whether to submit the form.
	if (isError == true) {
		alert("Missing required fields: " + errorMessage);
		return false;
	}

	return true;
}
// end hiding contents from old browsers  -->
</script>

</head>
<body>
<table cellspacing="0" cellpadding="0" border="0" align="center" class="shell">
<tr>
    <th width="400">Step 2: Database Configuration</th>
	<th width="200"><a href="http://www.sugarcrm.com" target="_blank"><img src="include/images/sugarcrm_logo.gif" alt="" width="150" height="29" border="0" align="right"></a></th>
</tr>
<tr>
    <td colspan="2" width="600">	
          <P>Please enter your database configuration information below... <P>

		  If you do not have root access to your database (for example you are installing in a virtual
		  hosting environment), you will need to have your database created for you before you proceed.
		  However, this installer will still be able to create the necessary database tables.<P>

		  If you unsure of your database host, username or password, we suggest that you use the default
		  values below. <P>
		  <span class="required">* Required field</span>
		  
		  <form action="install.php" method="post" onsubmit="return verify_data(setConfig);" name="setConfig" id="form">
			<input type="hidden" name="file" value="3confirmConfig.php">
			<table width="100%" cellpadding="0" cellpadding="0" border="0" class="StyleDottedHr">
              <tr>
			<th colspan="3" align="left">Database Configuration</td>
              </tr>
			  <tr>
               <td><span class="required">*</span></td><td nowrap><b>Host Name</b></td>
               <td align="left"><input type="text"  name="db_host_name" value="<?php if (isset($db_host_name)) echo "$db_host_name"; ?>" /></td>
              </tr>
              <tr>
               <td><span class="required">*</span></td><td nowrap><b>MySQL User Name</b></td>
               <td align="left"><input type="text"  name="db_user_name" value="<?php if (isset($db_user_name)) echo "$db_user_name"; ?>" /></td>
              </tr>
              <tr>
               <td></td><td nowrap><b>MySQL Password</b></td>
               <td align="left"><input type="password"  name="db_password" value="<?php if (isset($db_password)) echo "$db_password"; ?>" /></td>
              </tr>
              <tr>
               <td><span class="required">*</span></td><td nowrap><b>MySQL Database Name</b></td>
               <td align="left"><input type="text"  name="db_name" value="<?php if (isset($db_name)) echo "$db_name"; ?>" /></td>
              </tr>
              <tr>
               <td></td><td nowrap><b>Drop Existing Tables?</b></td>
               <td align="left"><input type="checkbox" class="checkbox" name="db_drop_tables"
			   <?php if (isset($db_drop_tables) && $db_drop_tables==true) echo "checked "; ?> value="$db_drop_tables"/></td>
              </tr>
			<th colspan="3" align="left">Site Configuration</td>
              </tr>
              <tr>
			<td><span class="required">*</span></td><td nowrap><b>URL</td>
            <td align="left"><input  type="text" name="site_URL"
			value="<?php if (isset($site_URL)) echo $site_URL; ?>" size="40" />
		  	</td>
          </tr><tr>
            <td><span class="required">*</span></td><td nowrap><b>Path</td>
            <td align="left"><input  type="text" name="root_directory" value="<?php if (isset($root_directory)) echo "$root_directory"; ?>" size="40" /> </td>
          </tr><tr valign="top">
            <td><span class="required">*</span></td><td nowrap><b>Path to Cache Directory<br>(must be writable)</td>
            <td align="left"><?php echo $root_directory.'\\'; ?><input  type="text" name="cache_dir" size='14' value="<?php if (isset($cache_dir)) echo $cache_dir; ?>" size="40" /> </td>
          </tr><tr>
            <td><span class="required">*</span></td><td nowrap><b>admin password</td>
            <td align="left"><input  type="password" name="admin_password" value="<?php if (isset($admin_password)) echo "$admin_password"; ?>" size="20" /></td>
          </tr>
          <tr>
            <td></td><td nowrap><b>admin email address</td>
            <td align="left"><input  type="text" name="admin_email" value="<?php if (isset($admin_email)) echo "$admin_email"; ?>" size="20" /></td>
   	      </tr></tbody>
			</table>
			
			
			
	</td>
</tr>
<tr>
	<td align="right" colspan="2">
	<hr>
	<table cellspacing="0" cellpadding="0" border="0" class="stdTable">
		<tr>
		    <td><input class="button" type="button" name="cancel" value="Cancel"  onclick="window.close();"/>&nbsp;&nbsp;&nbsp;&nbsp;<input class="button" type="button" name="back" value="Back"  onclick="history.back()"/></td>
		    <form action="install.php" method="post" name="form" id="form"><td>
		<input type="hidden" name="file" value="3confirmConfig.php" />
		<input class="button" type="submit" name="next" value="Next" />
				</form></td>
		</tr>
	</table>
	</td>
</tr>
</table>
<br>


</body>
</html>
